unit graphic;

interface

type vesa_vmode = record           { Informationen ber einen best. Videomodi }
       flag               : word;                                 { Modusflag }
       first_access       : byte;              { Flags fr 1. Zugriffsfenster }
       second_access      : byte;              { Flags fr 2. Zugriffsfenster }
       gran               : word;                     { Granularitt in KByte }
       size               : word; { Gre der beiden Zugriffsfenster in Kbyte }
       first_seg          : word;           { Segment des 1. Zugriffsfensters }
       second_seg         : word;           { Segment des 2. Zugriffsfensters }
       visible            : pointer; { FAR-Zeiger auf Proc fr sicht. Bereich }
       byte_per_line      : word;    { Bytes pro Punktzeile, ab hier optional }
       x_res              : word;                               { X-Auflsung }
       y_res              : word;                               { Y-Auflsung }
       x_size             : byte;                  { Breite der Zeichenmatrix }
       y_size             : byte;                    { Hhe der Zeichenmatrix }
       anz_bitplanes      : byte;                     { Anzahl der Bit-Planes }
       bits_per_pixel     : byte;       { Anzahl der Bits pro Bildschirmpunkt }
       anz_block          : byte;                 { Anzahl der Speicherblcke }
       mem_model          : byte;                            { Speichermodell }
       blocksize          : byte;         { Gre der Speicherblcke in KByte }
       dummy              : array [0..260] of byte;
       end;

     bmp_header = record
        signatur        : word;               { Signatur 'BM' der BMP-Datei }
        flen            : longint;                     { Filelnge in Bytes }
        dummy1          : word;                                { reserviert }
        dummy2          : word;                                { reserviert }
        offset          : longint;                { Offset auf Datenbereich }
        info_size       : longint;                       { Lnge Infoheader }
        xmax            : longint;                   { Bildbreite in Pixeln }
        ymax            : longint;                      { Bildhhe in Pixel }
        planes          : word;                   { Farbebenen (mu 1 sein) }
        bits_per_pixel  : word;               { Bits pro Pixel - 1, 2, 4, 8 }
        compress        : word;                         { Komprimierungstyp }
        xsize           : longint;                      { Bildgre in Byte }
        hdpi            : longint;                  { Bildauflsung in Pels }
        vdpi            : longint;                  { Bildauflsung in Pels }
        cols            : longint;              { Zahl der benutzten Farben }
        coli            : longint;              { Zahl der wichtigen Farben }
     end;
     vesa_info  = record                       { Information ber VESA-Karte }
      signature         : longint;                        { 'VESA' Signatur }
      version_low       : byte;             { untergeordnete Versionsnummer }
      version_high      : byte;              { bergeordnete Versionsnummer }
      name              : pointer;       { ASCIIZ-String auf Herstellername }
      flag              : pointer;                     { zur Zeit ungenutzt }
      modi              : pointer;         { Zeiger auf Liste der Videomodi }
      dummy             : array [0..237] of byte;
    end;

     ar=array[0..65534] of byte;


procedure outtextxy2(x,y:integer;texte:string;color:byte;info:vesa_vmode;var curpage,handle:word);
procedure vesamodeinfo (var info : vesa_vmode; mode : word);
procedure setvesamode(mode:word);
procedure setbank(bank : integer; p:pointer);
procedure putpixel_v(x,y:integer; col:byte; info:vesa_vmode;var curpage:word;handle:word);
function getpixel_v(x,y:word; info:vesa_vmode;var curpage,handle:word):byte;
procedure h_line_r(x1,x2,y:word; col:byte;info:vesa_vmode;var curpage,handle:word);
procedure d_line_r(x1,x2,y:word ;var source ;info:vesa_vmode;var curpage,handle:word);
procedure setdac (var dac);
procedure getdac (var dac);
procedure settext;
procedure loadtbm(name:string; sp:integer; var dacb; var handle:word);
procedure setemspage(page:longint;var handle:word);
function vesamodeavail (var info : vesa_info; modus : word) : boolean;
function vesainfo (var info : vesa_info) : boolean;


implementation

uses ems;

 const
    dac_pel_mask        = $3c6; { Register des Digital to Analog Converters }
    dac_state           = $3c7;
    dac_pel_read        = $3c7;
    dac_pel_write       = $3c8;
    dac_pel_data        = $3c9;

var pageframe:word;

function vesainfo (var info : vesa_info) : boolean; assembler;

asm
 mov ax, 4f00h
 les di, info
 int 10h
 cmp al, 4fh
 db 0fh, 94h, 0c0h
end;


function vesamodeavail (var info : vesa_info; modus : word) : boolean; assembler;

asm
 les  di, info
 add  di, 14
 les  di, dword ptr es:[di]
 mov  cx, modus
 mov  dx, 0ffffh
 mov  al, false

@v_1:
 cmp  dx, es:[di]
 je   @v_ende
 cmp  cx, es:[di]
 jne  @v_2
 mov  al, true
 jmp  @v_ende
@v_2:
 inc  di
 inc  di
 jmp  @v_1

@v_ende:
end;


procedure setemspage(page:longint;var handle:word);
var d:byte;
begin
 for d:=0 to 3 do setmapping(handle, page*4+d,d);
end;

procedure loadtbm(name:string; sp:integer; var dacb; var handle:word);

var f:file;
    header:bmp_header;
    buffer:^ar;
    i,d2,d3:integer;
    dac1,dac:array[0..768] of byte;
    page:integer;
    d,d4:longint;
    numread, xpos:word;

begin
  page:=sp;
  assign (f, name);
  reset (f, 1);
  blockread(f, dacb,768);
  savemapping(handle);
  repeat
  setemspage(page,handle);
  blockread(f,ptr(getpageframe,0)^,65535,numread);
  inc(page);
  until numread<65535;
  loadmapping(handle);
  close(f);
end;

procedure settext; assembler;
  asm
   mov ax,03h {Modus 3h laden}
   int 10h    {Int 10h ausfhren}
  end;

procedure outtextxy2(x,y:integer;texte:string;color:byte;info:vesa_vmode;var curpage,handle:word);

var point:pointer;
    d,d2,x2,y2,d3,num:word;
    st:string;
    d21,len:byte;


procedure putpixel_v_xor(x,y:integer; col:byte; info:vesa_vmode;var curpage,handle:word);
var l:longint;
    d,d2:word;
begin
  if (x<1)or(x>info.x_res-1)or(y<1)or(y>info.y_res-1) then exit;
  l:=y-1;
  l:=l*info.x_res;
  l:=l+x-1;
  d2:=l div 65536;
  if curpage<>d2 then
   begin
     for d:=0 to 3 do setmapping(handle, d2*4+d+4, d);
     curpage:=d2;
   end;
  mem[getpageframe:l]:=col;
end;


{liefert Adresse des Biosfonts (sieh Interruptabelle) }
procedure GetFontPointer (var p : pointer; font : byte); assembler;

asm
  push ds
  push bp
  mov  ax, 1130h
  mov  bh, font
  int  10h
  mov  ax, bp
  pop  bp
  lds  si, p
  mov  ds:[si], ax
  mov  ds:[si+02], es
  pop  ds
end;

begin
  getfontpointer(point,6); {liefert Adresse des Fonts}

  x2:=0;
  y2:=0;

  for len:=0 to length(texte)-1 do
  begin
    y2:=0;
    x2:=x+8*len; {Eine Zeile des Fonts=1 Byte, ein Buchstabe mit 16 Zeilen-->16 Byte/Buchstabe}
    num:=ord(texte[len+1]); {errechnet Pointer des gesuchten Buchstaben}
    for d3:=0 to 15 do
     begin
       d21:=mem[seg(point^):ofs(point^)+num*16+d3]; {Zeile auslesen}
       for d:=7 downto 0 do  {Wenn Bit gesetzt, dann Punkt setzen}
           if (d21 shr d) mod 2 = 1 then putpixel_v_xor(x2+7-d,y+y2,color,info,curpage,handle);
       inc(y2);
     end;
    end;

  end;

procedure vesamodeinfo (var info : vesa_vmode; mode : word); assembler;

asm
  mov  ax, 4f01h
  mov  cx, mode
  les  di, info
  int  10h
end;


procedure setvesamode(mode:word);
assembler;
asm
 mov ax, 4f02h
 xor bx, bx
 mov bx, mode
 int 10h
end;

procedure setbank(bank : integer; p:pointer); Assembler;
asm
   mov     ax, 4F05h {Neue Bank setzten}
   xor     bx, bx
   mov     dx, bank
   call    p {Pointer anspringen}
end;

procedure putpixel_v(x,y:integer; col:byte; info:vesa_vmode;var curpage:word;handle:word);
var l:longint;
    d,d2:word;
begin
  if (x<1)or(x>info.x_res-1)or(y<1)or(y>info.y_res-1) then exit;
  l:=y-1;
  l:=l*info.x_res;
  l:=l+x-1;
  d2:=l div 65536;
  if curpage<>d2 then
   begin
     for d:=0 to 3 do setmapping(handle, d2*4+d+4, d);
     curpage:=d2;
   end;
  mem[getpageframe:l mod 65536]:=col;
end;

{assembler;
var dummy,count,newpage:word;

asm

les di,info
add di, 18
mov bx, es:[di]
add di, 2
mov ax, es:[di] {bx=xres cx=yres}
{dec ax

cmp x, 1 {Vergleiche, ob Bild anzeigen, wenn nicht, dann raus}
{je @ende
cmp x, bx
jge @ende
cmp y, 1
je @ende
cmp y, ax
jge @ende

mov ax, y
dec ax
mul bx
add ax, x
dec ax
mov dummy, ax
les di, curpage
mov bx, es:[di]
cmp bx, dx
jz @put

mov newpage, dx

mov count, 4
@newmapping: mov ax,handle
             push ax

             mov ax, 4
             mul newpage
             add ax, count
             add ax, 4
             dec ax
             push ax

             mov ax, count
             dec ax
             push ax

             call setmapping

             dec count
jnz @newmapping

les di, curpage
mov ax, newpage
mov es:[di], ax

@put:
 mov ax, pageframe
 mov es, ax
 mov di, dummy
 mov al, col
 mov es:[di], al
@ende:

end;}


function getpixel_v(x,y:word; info:vesa_vmode;var curpage,handle:word):byte;
var l:longint;
    d,d2:word;
begin
  l:=y-1;
  l:=l*info.x_res;
  l:=l+x-1;
  d2:=l div 65536;
  if curpage<>d2 then
    begin
      for d:=0 to 3 do setmapping(handle, d2*4+d+4, d);
      curpage:=d2;
    end;
  getpixel_v:=mem[getpageframe:l];
end;

procedure d_line_r(x1,x2,y:word ;var source ;info:vesa_vmode;var curpage,handle:word);
var l1,l2:longint;
    d1,d2,d,cp:word;
begin
  l1:=y-1;
  l1:=l1*info.x_res;
  l1:=l1+x1-1;
  d1:=l1 div 65536;

  l2:=y-1;
  l2:=l2*info.x_res;
  l2:=l2+x2-1;
  d2:=l2 div 65536;

 if d1<>d2 then
   begin
     cp:=curpage;
     for d:=x1 to x2-1 do putpixel_v(d,y,mem[seg(source):ofs(source)+d-x1],info,cp,handle);
     curpage:=cp;
   end
  else
   begin
     if curpage<>d1 then
       begin
         for d:=0 to 3 do setmapping(handle, d1*4+d+4, d);
         curpage:=d1;
       end;
     move(ptr(seg(source),ofs(source))^, ptr(getpageframe,l1 mod 65536)^,x2-x1);
   end;
end;


procedure h_line_r(x1,x2,y:word; col:byte;info:vesa_vmode;var curpage,handle:word);
var l1,l2:longint;
    d1,d2,d,cp:word;
begin
  l1:=y-1;
  l1:=l1*info.x_res;
  l1:=l1+x1-1;
  d1:=l1 div 65536;

  l2:=y-1;
  l2:=l2*info.x_res;
  l2:=l2+x2-1;
  d2:=l2 div 65536;

 if d1<>d2 then
   begin
     cp:=curpage;
     for d:=x1 to x2-1 do putpixel_v(d,y,col,info,cp,handle);
     curpage:=cp;
   end
  else
   begin
     if curpage<>d1 then
       begin
         for d:=0 to 3 do setmapping(handle, d1*4+d+4, d);
         curpage:=d1;
       end;
     fillchar(ptr(getpageframe,l1 mod 65536)^,x2-x1,col);
   end;
end;

procedure setdac (var dac); assembler;

asm
   push ds { ds darf nicht verndert werden }

   mov  dx, dac_pel_write { dx = Pel Write Adress }
   xor  al, al  { Anfangsregister = 0 }
   out  dx, al
   inc  dx	{ dx = Pel Data Register }

   lds  si, dac  { ds:si --> Quelle }
   mov  cx, 768  { 768 DAC-Eintrge }
   cld           { bei Stringbefehlen aufwrts zhlen }
   rep outsb     { DAC-Werte laden und an Videokarte weiterleiten }

   pop  ds
   end;


procedure getdac (var dac); assembler;

asm
   mov  dx, dac_pel_read { dx = Pel Read Adress }
   xor  al, al  { Anfangsregister = 0 }
   out  dx, al
   inc  dx      { dx = Pel Data Register }
   inc  dx

   les  di, dac  { es:di --> Ziel }
   mov  cx, 768  { 768 DAC-Eintrge }
   cld           { bei Stringbefehlen aufwrts zhlen }
   rep  insb     { DAC-Werte von Videokarte lesen und in DAC sichern }
end;

begin
 pageframe:=getpageframe;
end.